Index: external/fastjet/contribs/RecursiveTools/ModifiedMassDropTagger.hh
===================================================================
--- external/fastjet/contribs/RecursiveTools/ModifiedMassDropTagger.hh	(revision d38348d6fa05d814372b4af29ec82c9928ff5be9)
+++ external/fastjet/contribs/RecursiveTools/ModifiedMassDropTagger.hh	(revision d38348d6fa05d814372b4af29ec82c9928ff5be9)
@@ -0,0 +1,123 @@
+// $Id: ModifiedMassDropTagger.hh 688 2014-06-17 14:29:56Z jthaler $
+//
+// Copyright (c) 2014-, Gavin P. Salam
+// based on arXiv:1307.007 by Mrinal Dasgupta, Simone Marzani and Gavin P. Salam
+//
+//----------------------------------------------------------------------
+// This file is part of FastJet contrib.
+//
+// It is free software; you can redistribute it and/or modify it under
+// the terms of the GNU General Public License as published by the
+// Free Software Foundation; either version 2 of the License, or (at
+// your option) any later version.
+//
+// It is distributed in the hope that it will be useful, but WITHOUT
+// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
+// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
+// License for more details.
+//
+// You should have received a copy of the GNU General Public License
+// along with this code. If not, see <http://www.gnu.org/licenses/>.
+//----------------------------------------------------------------------
+
+#ifndef __FASTJET_CONTRIB_MODIFIEDMASSDROPTAGGER_HH__
+#define __FASTJET_CONTRIB_MODIFIEDMASSDROPTAGGER_HH__
+
+#include "RecursiveSymmetryCutBase.hh"
+
+FASTJET_BEGIN_NAMESPACE      // defined in fastjet/internal/base.hh
+
+namespace contrib{
+
+//------------------------------------------------------------------------
+/// \class ModifiedMassDropTagger
+/// An implementation of the modified Mass-Drop Tagger from arXiv:1307.0007.
+///
+class ModifiedMassDropTagger : public RecursiveSymmetryCutBase {
+public:
+  
+  /// Simplified constructor, which takes just a symmetry cut (applied
+  /// on the scalar_z variable) and an optional subtractor.
+  ///
+  /// In this incarnation the ModifiedMassDropTagger is a bit of a
+  /// misnomer, because there is no mass-drop condition
+  /// applied. Recursion into the jet structure chooses the prong with
+  /// largest pt. (Results from arXiv:1307.0007 were based on the
+  /// largest mt, but this only makes a difference for values of the
+  /// symmetry_cut close to 1/2).
+  ///
+  /// If the (optional) pileup subtractor can be supplied, then see
+  /// also the documentation for the set_input_jet_is_subtracted() member
+  /// function.
+  ///
+  /// NB: The configuration of MMDT provided by this constructor is
+  /// probably the most robust for use with subtraction.
+  ModifiedMassDropTagger(double symmetry_cut, 
+                         const FunctionOfPseudoJet<PseudoJet> * subtractor = 0
+                         ) :
+    RecursiveSymmetryCutBase(scalar_z,  // the default SymmetryMeasure
+                             std::numeric_limits<double>::infinity(), // the default is no mass drop
+                             larger_pt, // the default RecursionChoice
+                             subtractor),
+    _symmetry_cut(symmetry_cut)
+  {}
+
+  /// Full constructor, which takes the following parameters:
+  ///
+  /// \param symmetry_cut       the value of the cut on the symmetry measure
+  /// \param symmetry_measure   the choice of measure to use to estimate the symmetry
+  /// \param mu_cut             the maximal allowed value of mass drop variable mu = m_heavy/m_parent 
+  /// \param recursion_choice   the strategy used to decide which subjet to recurse into
+  /// \param subtractor         an optional pointer to a pileup subtractor (ignored if zero)
+  ///
+  /// To obtain the mMDT as discussed in arXiv:1307.0007, use an
+  /// symmetry_measure that's one of the following
+  ///
+  /// - RecursiveSymmetryCutBase::y         (for a cut on y)
+  /// - RecursiveSymmetryCutBase::scalar_z  (for a cut on z)
+  ///
+  /// and use the default recursion choice of
+  /// RecursiveSymmetryCutBase::larger_pt (larger_mt will give something
+  /// very similar, while larger_m will give the behaviour of the
+  /// original, but now deprecated MassDropTagger)
+  ///
+  /// Notes: 
+  ///
+  /// - By default the ModifiedMassDropTagger will relcuster the jets
+  ///   with the C/A algorithm (if needed).
+  ///
+  /// - the mu_cut parameter is mostly irrelevant when it's taken
+  ///   larger than about 1/2: the tagger is then one that cuts
+  ///   essentially on the (a)symmetry of the jet's momentum
+  ///   sharing. The default value of infinity turns off its use
+  ///   entirely
+  ModifiedMassDropTagger(double           symmetry_cut, 
+                         SymmetryMeasure  symmetry_measure,
+                         double           mu_cut = std::numeric_limits<double>::infinity(), 
+                         RecursionChoice  recursion_choice = larger_pt,
+                         const FunctionOfPseudoJet<PseudoJet> * subtractor = 0
+                         ) : 
+    RecursiveSymmetryCutBase(symmetry_measure, mu_cut, recursion_choice, subtractor),
+    _symmetry_cut(symmetry_cut)
+  {}
+
+  /// default destructor
+  virtual ~ModifiedMassDropTagger(){}
+
+protected:
+
+  /// The symmetry cut function for MMDT returns just a constant, since the cut value
+  /// has no dependence on the subjet kinematics
+  virtual double symmetry_cut_fn(const PseudoJet & /* p1 */, 
+                                 const PseudoJet & /* p2 */
+                                 ) const {return _symmetry_cut;}
+  virtual std::string symmetry_cut_description() const;
+
+  double           _symmetry_cut;
+};
+
+} // namespace contrib
+
+FASTJET_END_NAMESPACE
+
+#endif  // __FASTJET_CONTRIB_MODIFIEDMASSDROPTAGGER_HH__
Index: external/fastjet/contribs/RecursiveTools/NEWS
===================================================================
--- external/fastjet/contribs/RecursiveTools/NEWS	(revision d38348d6fa05d814372b4af29ec82c9928ff5be9)
+++ external/fastjet/contribs/RecursiveTools/NEWS	(revision d38348d6fa05d814372b4af29ec82c9928ff5be9)
@@ -0,0 +1,2 @@
+2014/07/09: release of version 1.0.0 of RecursiveTools including
+            ModifiedMassDropTagger and SoftDrop (as well as Recluster)
Index: external/fastjet/contribs/RecursiveTools/README
===================================================================
--- external/fastjet/contribs/RecursiveTools/README	(revision d38348d6fa05d814372b4af29ec82c9928ff5be9)
+++ external/fastjet/contribs/RecursiveTools/README	(revision d38348d6fa05d814372b4af29ec82c9928ff5be9)
@@ -0,0 +1,186 @@
+------------------------------------------------------------------------
+RecursiveTools FastJet contrib
+------------------------------------------------------------------------
+
+The RecursiveTools FastJet contrib aims to provide a common contrib
+for a number of tools that involve recursive reclustering/declustering
+of a jet for tagging or grooming purposes.
+
+Currently it contains:
+
+- ModifiedMassDropTagger
+  This corresponds to arXiv:1307.0007 by Mrinal Dasgupta, Alessandro
+  Fregoso, Simone Marzani and Gavin P. Salam
+
+- SoftDrop
+  This corresponds to arXiv:1402.2657 by Andrew J. Larkoski, Simone
+  Marzani, Gregory Soyez, Jesse Thaler
+
+- Recluster
+  A generic tool to recluster a given jet into subjets
+  Note: this is largely based on the Filter code in FastJet v3.0 and
+  ultimately, this tool will probably be moved into FastJet
+
+The interface for these tools is described in more detail below, with
+all of the available options documented in the header files.
+
+One note about nomenclature.  A groomer is a procedure that takes a
+PseudoJet and always returns another (non-zero) PseudoJet.  A tagger is
+a procedure that takes a PseudoJet, and either returns another PseudoJet
+(i.e. tags it) or returns an empty PseudoJet (i.e. doesn't tag it).
+
+------------------------------------------------------------------------
+ModifiedMassDropTagger
+------------------------------------------------------------------------
+
+The Modified Mass Drop Tagger (mMDT) recursively declusters a jet,
+following the largest pT subjet until a pair of subjets is found that
+satisfy the symmetry condition on the energy sharing
+
+   z > z_cut
+
+where z_cut is a predetermined value.  By default, z is calculated as
+the scalar pT fraction of the softest subjet.  Note that larger values
+of z_cut correspond to a more restrictive tagging criteria.
+
+By default, mMDT will first recluster the jet using the CA clustering
+algorithm, which means that mMDT can be called on any jet, regardless
+of the original jet finding measure.
+
+A default mMDT can be created via
+
+   double z_cut = 0.10;
+   ModifiedMassDropTagger mMDT(z_cut);
+
+More options are available in the full constructor.  To apply mMDT,
+one simply calls it on the jet of interest.
+
+   PseudoJet tagged_jet = mMDT(original_jet);
+
+Note that mMDT is a tagger, such that tagged_jet will only be non-zero
+if the symmetry cut z > z_cut is satisfied by some branching of the
+clustering tree.  
+
+To gain additional information about the mMDT procedure, one can use
+
+   tagged_jet.structure_of<ModifiedMassDropTagger>()
+
+which gives access to information about the delta_R between the tagged
+subjets, their z value, etc.
+
+------------------------------------------------------------------------
+SoftDrop
+------------------------------------------------------------------------
+
+The SoftDrop procedure is very similar to mMDT, albeit with a 
+generalized symmetry condition:
+ 
+   z > z_cut * (R / R0)^beta
+
+Note that larger z_cut and smaller beta correspond to more aggressive
+grooming of the jet.
+
+SoftDrop is intended to be used as a groomer (instead of as a tagger),
+such that if the symmetry condition fails throughout the whole
+clustering tree, SoftDrop will still return a single particle in the
+end.  Apart from the tagger/groomer distinction, SoftDrop with beta=0 is
+the same as mMDT.
+
+A default SoftDrop groomer can be created via:
+
+   double z_cut = 0.10;
+   double beta  = 2.0;
+   double R0    = 1.0; // this is the default value
+   SoftDrop sd(z_cut,beta,R0);
+
+and acts on a desired jet as
+
+   PseudoJet groomed_jet = sd(original_jet);
+
+and additional information can be obtained via
+
+   groomed_jet.structure_of<SoftDrop>()
+
+SoftDrop is typically called with beta > 0, though beta < 0 is still a
+viable option.  Because beta < 0 is infrared-collinear unsafe in
+grooming mode, one probably wants to switch to tagging mode for negative
+beta, via set_tagging_mode().
+
+------------------------------------------------------------------------
+Recluster
+------------------------------------------------------------------------
+
+The Recluster class allows the constituents of a jet to be reclustered
+with a different recursive clustering algorithm.  This is used
+internally in the mMDT/SoftDrop code in order to recluster the jet using
+the CA algorithm.  This is achieved via
+
+  Recluster ca_reclusterer(cambridge_algorithm,
+                        JetDefinition::max_allowable_R);
+  PseudoJet reclustered_jet = ca_reclusterer(original_jet);
+
+Note that reclustered_jet creates a new ClusterSequence that knows to
+delete_self_when_unused.
+
+
+------------------------------------------------------------------------
+Changing behaviour
+------------------------------------------------------------------------
+
+The behaviour of the ModifiedMassDropTagger and SoftDrop classes can
+be tweaked using the following options:
+
+SymmetryMeasure = {scalar_z,vector_z,y}  [constructor argument]
+  : The definition of the energy sharing between subjets, with 0
+    corresponding to the most asymmetric
+
+RecursionChoice = {larger_pt,larger_mt,larger_m}  [constructor argument]
+  : The path to recurse through the tree after the symmetry condition
+    fails
+
+mu_cut   [constructor argument]
+  : An optional mass drop condition
+
+set_subtractor(subtractor*) [or subtracter as a constructor argument]
+  : provide a subtractor. When a subtractor is supplied, the
+    kinematic constraints are applied on subtracted 4-vectors. In
+    this case, the result of the ModifiedMassDropTagger/SoftDrop is a
+    subtracted PseudoJet, and it is assumed that
+    ModifiedMassDropTagger/SoftDrop is applied to an unsubtracted jet.
+    The latter default can be changed by calling
+    set_input_jet_is_subtracted().
+
+set_reclustering(bool, Recluster*)
+  : An optional setting to recluster a jet with a different jet
+    recursive jet algorithm.  The code is only designed to give sensible
+    results with the CA algorithm, but other reclustering algorithm
+    (especially kT) may be appropriate in certain contexts. 
+    Use at your own risk.
+
+set_grooming_mode()/set_tagging_mode()
+  : In grooming mode, the algorithm will return a single particle if the
+    symmetry condition fails for the whole tree.  In tagging mode, the
+    algorithm will return an zero PseudoJet if no symmetry conditions
+    passes.  Note that ModifiedMassDropTagger defaults to tagging mode
+    and SoftDrop defaults to grooming mode.
+
+------------------------------------------------------------------------
+Technical Details
+------------------------------------------------------------------------
+
+Both ModifiedMassDropTagger and SoftDrop inherit from
+RecursiveSymmetryCutBase, which provides a common codebase for recursive
+declustering of a jet with a symmetry cut condition.  A generic 
+RecursiveSymmetryCutBase depends on the following (virtual) functions
+(see header file for exact full specs, including constness):
+
+double symmetry_cut_fn(PseudoJet &, PseudoJet &)
+  : The function that defines the symmetry cut. This is what actually 
+    defines different recursive declustering schemes, and all classes
+    that inherit from RecursiveSymmetryCutBase must define this
+    function.
+
+string symmetry_cut_description() 
+  : the string description of the symmetry cut.
+
+------------------------------------------------------------------------
Index: external/fastjet/contribs/RecursiveTools/Recluster.cc
===================================================================
--- external/fastjet/contribs/RecursiveTools/Recluster.cc	(revision d38348d6fa05d814372b4af29ec82c9928ff5be9)
+++ external/fastjet/contribs/RecursiveTools/Recluster.cc	(revision d38348d6fa05d814372b4af29ec82c9928ff5be9)
@@ -0,0 +1,390 @@
+// $Id: Recluster.cc 699 2014-07-07 09:58:12Z gsoyez $
+//
+// Copyright (c) 2014-, Matteo Cacciari, Gavin P. Salam and Gregory Soyez
+//
+//----------------------------------------------------------------------
+// This file is part of FastJet contrib.
+//
+// It is free software; you can redistribute it and/or modify it under
+// the terms of the GNU General Public License as published by the
+// Free Software Foundation; either version 2 of the License, or (at
+// your option) any later version.
+//
+// It is distributed in the hope that it will be useful, but WITHOUT
+// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
+// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
+// License for more details.
+//
+// You should have received a copy of the GNU General Public License
+// along with this code. If not, see <http://www.gnu.org/licenses/>.
+//----------------------------------------------------------------------
+
+#include "Recluster.hh"
+#include <fastjet/ClusterSequenceActiveAreaExplicitGhosts.hh>
+#include <sstream>
+#include <typeinfo>
+
+using namespace std;
+
+// Comments:
+//
+//  - If the jet comes from a C/A clustering (or is a composite jet
+//    made of C/A clusterings) and we recluster it with a C/A
+//    algorithm, we just use exclusive jets instead of doing the
+//    clustering explicitly. In this specific case, we need to make
+//    sure that all the pieces share the same cluster sequence.
+//
+//  - If the recombiner has to be taken from the original jet and that
+//    jet is composite, we need to check that all the pieces were
+//    obtained with the same recombiner.
+//
+// TODO:
+//
+//  - check this actually works!!!
+
+FASTJET_BEGIN_NAMESPACE      // defined in fastjet/internal/base.hh
+
+namespace contrib{
+
+LimitedWarning Recluster::_explicit_ghost_warning;
+
+// class description
+string Recluster::description() const {
+  ostringstream ostr;
+  ostr << "Recluster with subjet_def = ";
+  if (_use_full_def) {
+    ostr << _subjet_def.description();
+  } else {
+    if (_subjet_alg == kt_algorithm) {
+      ostr << "Longitudinally invariant kt algorithm with R = " << _subjet_radius;
+    } else if (_subjet_alg == cambridge_algorithm) {
+      ostr << "Longitudinally invariant Cambridge/Aachen algorithm with R = " << _subjet_radius;
+    } else if (_subjet_alg == antikt_algorithm) {
+      ostr << "Longitudinally invariant anti-kt algorithm with R = " << _subjet_radius;
+    } else if (_subjet_alg == genkt_algorithm) {
+      ostr << "Longitudinally invariant generalised kt algorithm with R = " << _subjet_radius
+           << ", p = " << _subjet_extra;
+    } else if (_subjet_alg == cambridge_for_passive_algorithm) {
+      ostr << "Longitudinally invariant Cambridge/Aachen algorithm with R = " << _subjet_radius
+           << " and a special hack whereby particles with kt < " 
+           << _subjet_extra << "are treated as passive ghosts";
+    } else if (_subjet_alg == ee_kt_algorithm) {
+      ostr << "e+e- kt (Durham) algorithm";
+    } else if (_subjet_alg == ee_genkt_algorithm) {
+      ostr << "e+e- generalised kt algorithm with R = " << _subjet_radius
+           << ", p = " << _subjet_extra;
+    } else if (_subjet_alg == undefined_jet_algorithm) {
+      ostr << "uninitialised JetDefinition (jet_algorithm=undefined_jet_algorithm)" ;
+    } else {
+      ostr << "unrecognized jet_algorithm";
+    }
+    ostr << ", a recombiner obtained from the jet being reclustered";
+  }
+
+  if (_single)
+    ostr << " and keeping the hardest subjet";
+  else
+    ostr << " and joining all subjets in a composite jet";
+
+  return ostr.str();
+}
+
+// return a vector of subjets, which are the ones that would be kept
+// by the filtering
+PseudoJet Recluster::result(const PseudoJet &jet) const {
+  // generic sanity checks
+  //-------------------------------------------------------------------
+  // make sure that the jet has constituents
+  if (! jet.has_constituents())
+    throw Error("Filter can only be applied on jets having constituents");
+
+  // tests particular to certain configurations
+  //-------------------------------------------------------------------
+
+  // for a whole variety of checks, we shall need the "recursive"
+  // pieces of the jet (the jet itself or recursing down to its most
+  // fundamental pieces). So we do compute these once and for all.
+  //
+  // Note that the pieces are always needed (either for C/A or for the
+  // area checks)
+  vector<PseudoJet> all_pieces; //.clear();
+  if ((!_get_all_pieces(jet, all_pieces)) || (all_pieces.size()==0)){
+    throw Error("Recluster: failed to retrieve all the pieces composing the jet.");
+  }
+
+  // decide which jet definition to use
+  //-------------------------------------------------------------------
+  JetDefinition subjet_def;
+  if (_use_full_def){
+    subjet_def = _subjet_def;
+  } else {
+    _build_jet_def_with_recombiner(all_pieces, subjet_def);
+  }
+
+
+  // the vector that will ultimately hold the subjets
+  vector<PseudoJet> subjets;
+
+  // check if we can apply the simplification for C/A jets reclustered
+  // with C/A
+  //
+  // we apply C/A clustering iff
+  //  - the request subjet_def is C/A
+  //  - the jet is either directly coming from C/A or if it is a
+  //    superposition of C/A jets from the same cluster sequence
+  //  - the pieces agree with the recombination scheme of subjet_def
+  //
+  // Note that in this case area support will be automatically
+  // inherted so we can only worry about this later
+  //-------------------------------------------------------------------
+  if (_check_ca(all_pieces, subjet_def)){
+    _recluster_cafilt(all_pieces, subjets, subjet_def.R());
+    subjets = sorted_by_pt(subjets);
+    return _single
+      ? subjets[0]
+      : join(subjets, *(subjet_def.recombiner()));
+  }
+
+  // decide if area support has to be kept
+  //-------------------------------------------------------------------
+  bool include_area_support = jet.has_area();
+  if ((include_area_support) &&  (!_check_explicit_ghosts(all_pieces))){
+    _explicit_ghost_warning.warn("Recluster: the original cluster sequence is lacking explicit ghosts; area support will no longer be available after re-clustering");
+    include_area_support = false;
+  }
+
+  // extract the subjets
+  //-------------------------------------------------------------------
+  _recluster_generic(jet, subjets, subjet_def, include_area_support);
+  subjets = sorted_by_pt(subjets);
+
+  return _single
+    ? subjets[0]
+    : join(subjets, *(subjet_def.recombiner()));
+}
+
+//----------------------------------------------------------------------
+// the parts that really do the reclustering
+//----------------------------------------------------------------------
+
+// get the subjets in the simple case of C/A+C/A
+void Recluster::_recluster_cafilt(const vector<PseudoJet> & all_pieces, 
+                                  vector<PseudoJet> & subjets, 
+                                  double Rfilt) const{
+  subjets.clear();
+
+  // each individual piece should have a C/A cluster sequence
+  // associated to it. So a simple loop would do the job
+  for (vector<PseudoJet>::const_iterator piece_it = all_pieces.begin(); 
+       piece_it!=all_pieces.end(); piece_it++){
+    // just extract the exclusive subjets of 'jet'
+    const ClusterSequence *cs = piece_it->associated_cluster_sequence(); 
+    vector<PseudoJet> local_subjets;
+
+    double dcut = Rfilt / cs->jet_def().R();
+    if (dcut>=1.0){
+      local_subjets.push_back(*piece_it);
+    } else {
+      local_subjets = piece_it->exclusive_subjets(dcut*dcut);
+    }
+
+    copy(local_subjets.begin(), local_subjets.end(), back_inserter(subjets));
+  }
+}
+
+
+// set the filtered elements in the generic re-clustering case (w/o
+// subtraction)
+void Recluster::_recluster_generic(const PseudoJet & jet, 
+                                   vector<PseudoJet> & subjets,
+                                   const JetDefinition & subjet_def,
+                                   bool do_areas) const{
+  // create a new, internal, ClusterSequence from the jet constituents
+  // get the subjets directly from there
+  //
+  // If the jet has area support then we separate the ghosts from the
+  // "regular" particles so the subjets will also have area
+  // support. Note that we do this regardless of whether rho is zero
+  // or not.
+  //
+  // Note that to be able to separate the ghosts, one needs explicit
+  // ghosts!!
+  // ---------------------------------------------------------------
+  if (do_areas){
+    vector<PseudoJet> all_constituents = jet.constituents();
+    vector<PseudoJet> regular_constituents, ghosts;  
+
+    for (vector<PseudoJet>::iterator it = all_constituents.begin(); 
+         it != all_constituents.end(); it++){
+      if (it->is_pure_ghost())
+        ghosts.push_back(*it);
+      else
+        regular_constituents.push_back(*it);
+    }
+
+    // figure out the ghost area from the 1st ghost (if none, any value
+    // would probably do as the area will be 0 and subtraction will have
+    // no effect!)
+    double ghost_area = (ghosts.size()) ? ghosts[0].area() : 0.01;
+    ClusterSequenceActiveAreaExplicitGhosts * csa
+      = new ClusterSequenceActiveAreaExplicitGhosts(regular_constituents, 
+                                                    subjet_def, 
+                                                    ghosts, ghost_area);
+
+    subjets = csa->inclusive_jets();
+
+    // allow the cs to be deleted when it's no longer used
+    // 
+    // Note that there is at least one constituent in the jet so there
+    // is in principle at least one subjet But one may have used a
+    // nasty recombiner that left an empty set of subjets, so we'd
+    // rather play it safe
+    if (subjets.size())
+      csa->delete_self_when_unused();
+    else
+      delete csa;
+  } else {
+    ClusterSequence * cs = new ClusterSequence(jet.constituents(), subjet_def);
+    subjets = cs->inclusive_jets();
+    // allow the cs to be deleted when it's no longer used (again, we
+    // add an extra safety check)
+    if (subjets.size())
+      cs->delete_self_when_unused();
+    else 
+      delete cs;
+  }
+}
+
+
+//----------------------------------------------------------------------
+// various checks and internal constructs
+//----------------------------------------------------------------------
+
+// fundamental info for CompositeJets
+//----------------------------------------------------------------------
+ 
+// get the pieces down to the fundamental pieces
+// 
+// Note that this just checks that there is an associated CS to the
+// fundamental pieces, not that it is still valid
+bool Recluster::_get_all_pieces(const PseudoJet &jet, vector<PseudoJet> &all_pieces) const{
+  if (jet.has_associated_cluster_sequence()){
+    all_pieces.push_back(jet);
+    return true;
+  }
+
+  if (jet.has_pieces()){
+    const vector<PseudoJet> pieces = jet.pieces();
+    for (vector<PseudoJet>::const_iterator it=pieces.begin(); it!=pieces.end(); it++)
+      if (!_get_all_pieces(*it, all_pieces)) return false;
+    return true;
+  }
+
+  return false;
+}
+
+// treatment of recombiners
+//----------------------------------------------------------------------
+// get the common recombiner to all pieces (NULL if none)
+//
+// Note that if the jet has an associated cluster sequence that is no
+// longer valid, an error will be thrown (needed since it could be the
+// 1st check called after the enumeration of the pieces)
+const JetDefinition::Recombiner* Recluster::_get_common_recombiner(const vector<PseudoJet> &all_pieces) const{
+  const JetDefinition & jd_ref = all_pieces[0].validated_cs()->jet_def();
+  for (unsigned int i=1; i<all_pieces.size(); i++)
+    if (!all_pieces[i].validated_cs()->jet_def().has_same_recombiner(jd_ref)) return NULL;
+
+  return jd_ref.recombiner();
+}
+  
+void Recluster::_build_jet_def_with_recombiner(const vector<PseudoJet> &all_pieces, 
+                                               JetDefinition &subjet_def) const{
+  // the recombiner has to be guessed from the pieces
+  const JetDefinition::Recombiner * common_recombiner = _get_common_recombiner(all_pieces);
+  if (common_recombiner) {
+    if (typeid(*common_recombiner) == typeid(JetDefinition::DefaultRecombiner)) {
+      RecombinationScheme scheme = 
+        static_cast<const JetDefinition::DefaultRecombiner *>(common_recombiner)->scheme();
+      if (_has_subjet_extra)
+        subjet_def = JetDefinition(_subjet_alg, _subjet_radius, _subjet_extra, scheme);
+      else if (_has_subjet_radius)
+        subjet_def = JetDefinition(_subjet_alg, _subjet_radius, scheme);
+      else 
+        subjet_def = JetDefinition(_subjet_alg, scheme);
+    } else {
+      if (_has_subjet_extra)
+        subjet_def = JetDefinition(_subjet_alg, _subjet_radius, _subjet_extra, common_recombiner);
+      else if (_has_subjet_radius)
+        subjet_def = JetDefinition(_subjet_alg, _subjet_radius, common_recombiner);
+      else 
+        subjet_def = JetDefinition(_subjet_alg, common_recombiner);
+    }
+  } else {
+    throw Error("Recluster: requested to guess the recombination scheme (or recombiner) from the original jet but an inconsistency was found between the pieces constituing that jet.");
+  }
+}
+
+// area support
+//----------------------------------------------------------------------
+
+// check if the jet (or all its pieces) have explicit ghosts
+// (assuming the jet has area support).
+//
+// Note that if the jet has an associated cluster sequence that is no
+// longer valid, an error will be thrown (needed since it could be the
+// 1st check called after the enumeration of the pieces)
+bool Recluster::_check_explicit_ghosts(const vector<PseudoJet> &all_pieces) const{
+  for (vector<PseudoJet>::const_iterator it=all_pieces.begin(); it!=all_pieces.end(); it++)
+    if (! it->validated_csab()->has_explicit_ghosts()) return false;
+  return true;
+}
+
+// C/A specific tests
+//----------------------------------------------------------------------
+
+// check if one can apply the simplification for C/A subjets
+//
+// This includes:
+//  - the subjet definition asks for C/A subjets
+//  - all the pieces share the same CS
+//  - that CS is C/A with the same recombiner as the subjet def
+//  - the filtering radius is not larger than any of the pairwise
+//    distance between the pieces
+//
+// Note that if the jet has an associated cluster sequence that is no
+// longer valid, an error will be thrown (needed since it could be the
+// 1st check called after the enumeration of the pieces)
+bool Recluster::_check_ca(const vector<PseudoJet> &all_pieces, 
+                          const JetDefinition &subjet_def) const{
+  if (subjet_def.jet_algorithm() != cambridge_algorithm) return false;
+
+  // check that the 1st of all the pieces (we're sure there is at
+  // least one) is coming from a C/A clustering. Then check that all
+  // the following pieces share the same ClusterSequence
+  const ClusterSequence * cs_ref = all_pieces[0].validated_cs();
+  if (cs_ref->jet_def().jet_algorithm() != cambridge_algorithm) return false;
+  for (unsigned int i=1; i<all_pieces.size(); i++)
+    if (all_pieces[i].validated_cs() != cs_ref) return false;
+
+  // check that the 1st peice has the same recombiner as the one used
+  // for the subjet clustering
+  // Note that since they share the same CS, checking the 1st one is enough
+  if (!cs_ref->jet_def().has_same_recombiner(subjet_def)) return false;
+
+  // we also have to make sure that the reclustering radius is not larger
+  // than any of the inter-pieces distance
+  double Rsub2 = subjet_def.R();
+  Rsub2 *= Rsub2;
+  for (unsigned int i=0; i<all_pieces.size()-1; i++){
+    for (unsigned int j=i+1; j<all_pieces.size(); j++){
+      if (all_pieces[i].squared_distance(all_pieces[j]) <  Rsub2) return false;
+    }
+  }
+
+  return true;
+}
+
+} // contrib namespace
+
+FASTJET_END_NAMESPACE      // defined in fastjet/internal/base.hh
